#include <stdio.h>
#include <stdlib.h>
#include <curses.h>
#include <time.h>
#define NU 40

int main (int argc, char *argv[])
    {
    FILE *fp;
    WINDOW *win;
    char ph[50],pp[6],ch,pl[NU][50],o[NU][6],st[NU][5],player[7][6];
    int plnum,count,a,c,z,i,smo,x,y;
    int pr[NU],h[NU],mo[6],loc[6],rent[NU],hc[NU];
    unsigned int dice[3];
    int aroll;
    int hn[4],ex,stop;
    char ra[4][50],in[100],fop[100];
    char sellto[5],code[50],*homepath=getenv("HOME");
    int sellp;
    int passgo,dbsfine;
    
    initscr();
    getmaxyx(stdscr,y,x);
    if(y!=25||x!=80)
	{
	printw("Your terminal is not the right size(25x80)\nPlay anyway?(if you play anyway then the game may look very wierd or not work right).press y or n\n");
	noecho();
	while(ch!='y'&&ch!='n')
	    ch=getch();
	echo();
	if(ch=='n')
	    die();
	ch='\000';
	}
    if (argc==1||argc>7)
	{
	printw("Usage : %s name1 name2 [name3] [name4]....\nnames may be no more than five letters long\n",argv[0]);
	refresh();
	die();
	}
    if(strcmp(argv[1],"--help")==0)
	{
	printw("Usage : %s name1 name2 [name3] [name4]....\nnames may be no more than five letters long\n",argv[0]);
	refresh();
	die();
	}
    printw("Do you want auto dice rolling?\n");
    noecho();
    while(ch!='y'&&ch!='n')
	ch=getch();
    echo();
    if(ch=='n')
	aroll=0;
    else
	aroll=1;
    if(argc!=2)
	{
	plnum=(argc-1);
	for(c=0;c<plnum;c++)
	    {
	    if(strlen(argv[c+1])>5)
		{
		printw("One (or more) of the players names are more than 5 letters long. Exiting.....\n(Tip: just use initials)\n");
		refresh();
		die();
		}
	    memset(player[c],0,sizeof player[c]);
	    strncpy(player[c],argv[c+1],(sizeof player[c])-1);
	    }
	}
    srand(time(NULL));
    fp = fopen("monoUSArc.data","r");
    if(!fp)
	{
	printw("MonoUSA could not find data file. exiting....\n");
	die();
	}
    printw("Loading game");
    for(c=0;c<NU;c++)
	{
	fscanf(fp,"%d %s %d %d",&pr[c],&pl[c],&rent[c],&hc[c]);
	usleep(50000);
	refresh();
	printw(".");
	}
    printw("done\n");
    refresh();
    clear();
    fscanf(fp,"%d %d %d",&smo,&passgo,&dbsfine);
    fclose(fp);
    strcpy(pp,"#*&+?%");
    if (argc!=2)
	{
	for(c=0;c<NU;c++)
	    strcpy(st[c]," ");
	for(c=0;c<NU;c++)
	    h[c]=0;
	for(c=0;c<=plnum;c++)
	    loc[c]=-1;
	for(c=0;c<NU;c++)
	    strcpy(o[c],"bank");
	for(c=0;c<plnum;c++)
	    mo[c]=smo;
	/*printing board*/
	printw("\t\t\t");
	standout();
	printw("[GO--------<<<<-----------]\n");
	standend();
	for(c=0,z=39;c<20,z>19;c++,z--)
	    {
	    printw("%d %s\t%s\t",h[c],o[c],pl[c]);
	    standout();
	    printw("[%s]",st[c]);
	    standend();
	    printw("\t$%d\t$%d\t",pr[c],pr[z]);
	    standout();
	    printw("[%s]",st[z]);
	    standend();
	    printw("\t%s\t%d %s\n",pl[z],h[z],o[z]);
	    }
	printw("\t\t\t");
	standout();
	printw("[---------->>>>-----------]\n");
	standend();
	/*end printing board*/
	for(count=0;count<plnum;count++)
	    printw("%d\t",mo[count]);
	printw("\n");
	for(count=0;count<plnum;count++)
	    printw("%s\t",player[count]);
	printw("\n");
	i=0;
	}
    else
	{
	sprintf(fop,"%s/%s.monou",homepath,argv[1]);
	fp=fopen(fop,"r");
	if(!fp)
	    {
	    printw("MonoUSA could not find game \"%s\". exiting....\n",argv[1]);
	    die();
	    }
	fscanf(fp,"%s",&code);
	if(strcmp(code,"qwertyuioplkmjnhbgvfcdxszb")!=0)
	    {
	    printw("%s is not the right kind of file or was saved by the wrong version of monoUSA(this is version 2.0). Exiting....\n",argv[1]);
	    fclose(fp);
	    die();
	    }
	fscanf(fp,"%d %d",&i,&plnum);
	if(i==plnum-1)
	    i=0;
	else
	    i++;
	for(z=0;z<plnum;z++)
	    fscanf(fp,"%s %d %d",&player[z],&loc[z],&mo[z]);
	printw("Loading saved game");
	for(z=0;z<40;z++)
	    {
	    fscanf(fp,"%s %s %d",&o[z],&st[z],&h[z]);
	    usleep(50000);
	    refresh();
	    printw(".");
	    }
	printw("done\n");
	refresh();
	clear();
	for(z=0;z<40;z++)
	    {
	    if(strcmp("b",st[z])==0)
		strcpy(st[z]," ");
	    }
	/*printing board*/
	printw("\t\t\t");
	standout();
	printw("[GO--------<<<<-----------]\n");
	standend();
	for(c=0,z=39;c<20,z>19;c++,z--)
	    {
	    printw("%d %s\t%s\t",h[c],o[c],pl[c]);
	    standout();
	    printw("[%s]",st[c]);
	    standend();
	    printw("\t$%d\t$%d\t",pr[c],pr[z]);
	    standout();
	    printw("[%s]",st[z]);
	    standend();
	    printw("\t%s\t%d %s\n",pl[z],h[z],o[z]);
	    }
	printw("\t\t\t");
	standout();
	printw("[---------->>>>-----------]\n");
	standend();
	/*end printing board*/
	for(count=0;count<plnum;count++)
	    printw("$%d\t",mo[count]);
	printw("\n");
	for(count=0;count<plnum;count++)
	    printw("%s\t",player[count]);
	printw("\n");
	}
    while(ch!='q'&&ch!='b')
	{
	standout();
	printw("It is %s's turn",player[i]);
	standend();
	if(aroll==1)
	    {
	    dice[0]=1+(rand()%6);
	    dice[1]=1+(rand()%6);
	    printw("  dice:%d and %d\n",dice[0],dice[1]);
	    }
	else
	    {
	    nodelay(stdscr,TRUE);
	    noecho();
	    z=1;
	    printw("  dice:  and   ");
	    printw("   Press space to stop rolling\n");
	    while(ch!=' ')
		{
		ch=getch();
		if(z==6)
		    z=0;
		z++;
		mvprintw(24,20+strlen(player[i]),"%d",z);
		}
	    move(24,28+strlen(player[i]));
	    clrtoeol();
	    printw("Press n to roll next die");
	    ch='\000';
	    dice[0]=z;
	    while(getch()!='n')
		;
	    move(24,28+strlen(player[i]));
	    clrtoeol();
	    printw("Press space to stop rolling");
	    while(ch!=' ')
		{
		ch=getch();
		if(z==6)
		    z=0;
		z++;
		mvprintw(24,26+strlen(player[i]),"%d",z);
		}
	    dice[1]=z;
	    move(24,28+strlen(player[i]));
	    clrtoeol();
	    echo();
	    move(24,28+strlen(player[i]));
	    nodelay(stdscr,FALSE);
	    }
	if(dice[1]==dice[0])
	    {
	    printw(" Got doubles -$%d",dbsfine);
	    mo[i]-=dbsfine;
	    }
	dice[2]=dice[0]+dice[1];

	if(st[loc[i]][strlen(st[loc[i]])]!=pp[i]&&strlen(st[loc[i]])>1)
	    st[loc[i]][strlen(st[loc[i]])-1]='\0';
	else
	    strcpy(st[loc[i]]," ");
	if(dice[2]+loc[i]>39)
	    {
	    printw(" Passed go. +$%d ",passgo);
	    mo[i]+=passgo;
	    loc[i]=0+((dice[2]+loc[i])-NU);
	    }
	else
	    loc[i]=loc[i]+dice[2];
	if(strcmp(st[loc[i]]," ")!=0)
	    {
	    strcpy(ph,st[loc[i]]);
	    sprintf(st[loc[i]],"%c%s",pp[i],ph);
	    }
	else
	    sprintf(st[loc[i]],"%c",pp[i]);
	refresh();
	if(strcmp(o[loc[i]],"bank")==0)
	    {
	    raw();
	    win=subwin(stdscr,5,46+strlen(player[i])+strlen(pl[loc[i]]),10,10);
	    wclear(win);
	    wmove(win,2,3);
	    wprintw(win,"Do you want to buy property %s for $%d, %s?",pl[loc[i]],pr[loc[i]],player[i]);
	    box(win, '|', '-');
	    wmove(win,3,3);
	    wrefresh(win);
	    noraw();
	    stop=1;
	    memset(in,0,sizeof in);
	    while(in[0] != 'y' && in[0] != 'n')
		wscanw(win,"%s",&in);
	    if(in[0]=='y')
		{
		mo[i]=mo[i]-pr[loc[i]];
		strcpy(o[loc[i]],player[i]);
		}
	    if(in[1]=='y')
		stop=0;
	    delwin(win);
	    refresh();
	    }
	else
	    {
	    h[loc[i]]++;
	    clear();
	    win=subwin(stdscr,5,40+strlen(player[i]),10,15);
	    box(win, '|', '-');
	    wmove(win,2,3);
	    raw();
	    wprintw(win,"You (%s) need to pay $%d rent to %s\n",player[i],(rent[loc[i]]*h[loc[i]]),o[loc[i]]);
	    box(win, '|', '-');
	    noraw();
	    wmove(win,3,3);
	    wrefresh(win);
	    stop=1;
	    memset(in,0,sizeof in);
	    while(in[0] != 'y' && in[0] != 'n')
		wscanw(win,"%s",&in);
	    if(in[1]=='y')
		stop=0;
	    wmove(win,3,3);
	    mo[i]=mo[i]-(rent[loc[i]]*h[loc[i]]);
	    for(z=0;z<plnum;z++)
		if(strcmp(o[loc[i]],player[z])==0)
		    {
		    mo[z]+=(rent[loc[i]]*h[loc[i]]);
		    wprintw(win,"Rent paid\n");
		    break;
		    }
	    delwin(win);
	    h[loc[i]]--;
	    }
	ch='\0';
	while(ch!='i'&&ch!='y'&&ch!='v'&&ch!='s'&&ch!='q'&&ch!='c')
	    {
	    clear();
	    /*printing board*/
	    printw("\t\t\t");
	    standout();
	    printw("[GO--------<<<<-----------]\n");
	    standend();
	    for(c=0,z=39;c<20,z>19;c++,z--)
		{
		printw("%d %s\t%s\t",h[c],o[c],pl[c]);
		standout();
		printw("[%s]",st[c]);
		standend();
		printw("\t$%d\t$%d\t",pr[c],pr[z]);
		standout();
		printw("[%s]",st[z]);
		standend();
		printw("\t%s\t%d %s\n",pl[z],h[z],o[z]);
		}
	    printw("\t\t\t");
	    standout();
	    printw("[---------->>>>-----------]\n");
	    standend();
	    /*end printing board*/
	    for(count=0;count<plnum;count++)
		printw("$%d\t",mo[count]);
	    printw("\n");
	    for(count=0;count<plnum;count++)
		printw("%s\t",player[count]);
	    printw("\n");
	    printw("(i)nfo  sa(v)e  (s)ell  (q)uit (c)ontinue or (y)\n");
	    refresh();
	    if(stop==1)
		scanw("%c",&ch);
	    if(stop==0)
		{
		ch='c';
		stop=1;
		}
	    }
	if(ch=='i')
	    {
	    scrollok(stdscr,TRUE);
	    clear();
	    memset(in,0,sizeof in);
	    printw("Tip #1: When a window pops up and asks if you want to buy something or tells\nyou that you have to pay rent, then press yy rather then just y to fast forward\npast the options part\n");
	    printw("Tip #2: If you find any bugs then e-mail me at (if I still use this address)\ngarret_mcgraw@yahoo.com thanks!!!\n");
	    printw("Game info:\nPlayers, players money, and players playing pieces are:\n");
	    for(count=0;count<plnum;count++)
		printw("%s\t",player[count]);
	    printw("\n");
	    for(count=0;count<plnum;count++)
		printw("$%d\t",mo[count]);
	    printw("\n");
	    for(count=0;count<plnum;count++)
		printw("%c\t",pp[count]);
	    printw("\n");
	    printw("There are %d players in the game and ",plnum);
	    for(z=0,count=0;z<NU;z++)
		count+=h[z];
	    printw("there are %d houses built\n",count);
	    printw("Here is a list of all the propertys:\n");
	    for(z=0;z<NU;z+=4)
		{
		for(count=0;count<4;count++)
		    printw("%s\t",pl[z+count]);
		printw("\n");
		}
	    printw("What property do you want info on? (If none then just press enter)\n");
	    refresh();
	    scanw("%s",&in);
	    for(z=0;z<40;z++)
		{
		if(strcmp(pl[z],in)==0)
		    {
		    printw("Cost is $%d it has %d houses and the cost of houses is $%d owner is %s \nstatus of it is [%s] it belongs to group %c \n",pr[z],h[z],hc[z],o[z],st[z],pl[z][0]);
		    printw("Rent for %s is:\n$%d with no houses\n$%d with one house\n$%d with two houses\n",pl[z],rent[z],rent[z]*2,rent[z]*3);
		    refresh();
		    }
		}
	    printw("\nPress y or c to continue\n");
	    ch='\0';
	    while(ch!='y'&&ch!='c')
		scanw("%c",&ch);
	    clear();
	    scrollok(stdscr,FALSE);
	    }
	if(ch=='v')
	    {
	    for(z=0;z<40;z++)
		{
		if(strcmp(" ",st[z])==0)
		    strcpy(st[z],"b");
		}
	    if(argc!=2)
		{
		printw("What file do you want game saved into?\n");
		memset(in,0,sizeof in);
		refresh();
		scanw("%s",&in);
		sprintf(fop,"%s/%s.monou",homepath,in);
		}
	    fp = fopen(fop,"w");
	    if(!fp)
		{
		printw("MonoUSA could not open file \"%s\" for writing. game not stopped....\nPress c to continue\n",fop);
		argc=plnum+1;
		while(getch()!='c')
		    ;
		}
	    else
		{
		fprintf(fp,"qwertyuioplkmjnhbgvfcdxszb\n");
		fprintf(fp,"%d %d\n",i,plnum);
		for(z=0;z<plnum;z++)
		    fprintf(fp,"%s %d %d\n",player[z],loc[z],mo[z]);
		scrollok(stdscr,TRUE);
		printw("Saving game");
		for(z=0;z<40;z++)
		    {
		    fprintf(fp,"%s %s %d\n",o[z],st[z],h[z]);
		    printw(".");
		    usleep(50000);
		    refresh();
		    }
		printw("done\n");
		refresh();
		fclose(fp);
		die();
		}
	    }
	if(ch=='q')
	    {
	    printw("Do you really want to end the game?  \n");
	    refresh();
	    while(ch!='y'&&ch!='n')
		scanw("%c",&ch);
	    if (ch=='y')
		ch='q';
	    }
	if(ch=='s')
	    {
	    clear();
	    memset(in,0,sizeof in);
	    /*printing board*/
	    printw("\t\t\t");
	    standout();
	    printw("[GO--------<<<<-----------]\n");
	    standend();
	    for(c=0,z=39;c<20,z>19;c++,z--)
		{
		printw("%d %s\t%s\t",h[c],o[c],pl[c]);
		standout();
		printw("[%s]",st[c]);
		standend();
		printw("\t$%d\t$%d\t",pr[c],pr[z]);
		standout();
		printw("[%s]",st[z]);
		standend();
		printw("\t%s\t%d %s\n",pl[z],h[z],o[z]);
		}
	    printw("\t\t\t");
	    standout();
	    printw("[---------->>>>-----------]\n");
	    standend();
	    /*end printing board*/
	    for(count=0;count<plnum;count++)
		printw("$%d\t",mo[count]);
	    printw("\n");
	    for(count=0;count<plnum;count++)
		printw("%s\t",player[count]);
	    printw("\n");
	    printw("What property do you want to sell %s?  ",player[i]);
	    refresh();
	    scanw("%s",&in);
	    for(c=0;c<40;c++)
		if(strcmp(pl[c],in)==0&&strcmp(o[c],"bank")!=0&&strcmp(o[c],player[i])==0)
		    {
		    clear();
		    printw("Who do you want to sell %s to?   ",pl[c]);
		    refresh();
		    scanw("%s",&sellto);
		    for(z=0;z<3;z++)
			if(strcmp(player[z],sellto)==0)
			    {
			    printw("What price do you want to sell %s to %s for?\nThe bank sold it for $%d\nIt has %d houses on it  ",pl[c],player[z],pr[c],h[c]);
			    refresh();
			    scanw("%d",&sellp);
			    strcpy(o[c],player[z]);
			    mo[z]-=sellp;
			    mo[i]+=sellp;
			    }
		    }
	    }
	/*clear();*/
	ex=0;
	a=0;
	memset(in,0,sizeof in);
	scrollok(stdscr,TRUE);
	for(c=0;c<40;c++)/*this is the begining of house check*/
	    {
	    if(strcmp(o[c],player[i])==0)
		{
		ex=0;
		a=0;
		strcpy(ra[0],pl[c]);
		hn[0]=c;
		c++;
		a+=1;
		if(strcmp(o[c],player[i])==0&&pl[c][0]==ra[0][0])
		    {
		    strcpy(ra[1],pl[c]);
		    hn[1]=c;
		    c++;
		    a+=1;
		    if(strcmp(o[c],player[i])==0&&pl[c][0]==ra[1][0])
			{
			strcpy(ra[2],pl[c]);
			hn[2]=c;
			c++;
			a+=1;
			if(h[hn[0]]<2||h[hn[1]]<2||h[hn[2]]<2)
			    if(ra[0][0]!='m')
				ex=1;
			if(strcmp(o[c],player[i])==0&&pl[c][0]==ra[2][0])
			    {
			    strcpy(ra[3],pl[c]);
			    hn[3]=c;
			    c++;
			    a+=1;
			    if(h[hn[0]]<2||h[hn[1]]<2||h[hn[2]]<2|h[hn[3]]<2)
				ex=2;
			    }
			}
		    }
		if(ex==2||ex==1)
		    {
		    clear();
		    if(ex==2)
			printw("Hi %s welcome to your friendely real estate dealer\nDo you want houses on %s %s %s or %s?\nPress q to leave the real estate office\n",player[i],pl[hn[0]],pl[hn[1]],pl[hn[2]],pl[hn[3]]);
		    if(ex==1)
			printw("Hi %s welcome to your friendley real estate dealer\nDo you want houses on %s %s or %s?\nPress q to leave the real estate office\n",player[i],pl[hn[0]],pl[hn[1]],pl[hn[2]]);
		    while(strcmp(in,"q")!=0)
			{
			refresh();
			scanw("%s",&in);
			for(z=0;z<(ex+2);z++)
			    {
			    if(strcmp(in,pl[hn[z]])==0)
				{
				if(h[hn[z]]<2)
				    {
				    h[hn[z]]+=1;
				    mo[i]-=hc[hn[z]];
				    printw("Building house");
				    for(count=0;count<10;count++)
					{
					printw(".");
					refresh();
					usleep(200000);
					}
				    printw("Your house is built\n");
				    }
				else
				    printw("It already has two houses\n");
				}
			    }
			}
		    }
		if(ex==0)
		    {
		    for(z=0;z<4;z++)
			memset(ra[z],0,sizeof ra[z]);
		    c-=a;
		    }
		}
	    }/*this is the end of house check*/
	scrollok(stdscr,FALSE);
	if(mo[i]<1)
	    {
	    clear();
	    ex=0;
	    for(z=0;z<NU;z++)
		{
		if(strcmp(o[z],player[i])==0)
		    {
		    ex=1;
		    break;
		    }
		}
	    if(ex==1)
		{
		ex=0;
		memset(in,0,sizeof in);
		while(ex!=1)
		    {
		    /*printing board (bankrupt board)*/
		    standout();
		    printw("You are bankrupt, %s",player[i]);
		    standend();
		    printw("\t");
		    standout();
		    printw("[GO--------<<<<-----------]");
		    standend();
		    printw("\t");
		    standout();
		    printw("You have $%d\n",mo[i]);
		    standend();
		    for(c=0,z=39;c<20,z>19;c++,z--)
			{
			printw("%d %s\t%s\t",h[c],o[c],pl[c]);
			standout();
			printw("[%s]",st[c]);
			standend();
			printw("\t$%d\t$%d\t",pr[c],pr[z]);
			standout();
			printw("[%s]",st[z]);
			standend();
			printw("\t%s\t%d %s\n",pl[z],h[z],o[z]);
			}
		    printw("\t\t\t");
		    standout();
		    printw("[---------->>>>-----------]\n");
		    standend();
		    /*end printing board*/
		    printw("You (%s) have to sell one of your propertys to the bank\nyou only get half of what it is worth\nyou get to pick that property  ",player[i]);
		    refresh();
		    scanw("%s",&in);
		    clear();
		    for(c=0;c<NU;c++)
			if(strcmp(in,pl[c])==0&&strcmp(o[c],player[i])==0)
			    {
			    strcpy(o[c],"bank");
			    mo[i]+=(pr[c]/2);
			    ex=1;
			    }
		    }
		}
	    else
		{
		scrollok(stdscr,TRUE);
		ch='b';
		}
	    }
	if(ch!='q')
	    clear();
	/*printing board*/
	printw("\t\t\t");
	standout();
	printw("[GO--------<<<<-----------]\n");
	standend();
	for(c=0,z=39;c<20,z>19;c++,z--)
	    {
	    printw("%d %s\t%s\t",h[c],o[c],pl[c]);
	    standout();
	    printw("[%s]",st[c]);
	    standend();
	    printw("\t$%d\t$%d\t",pr[c],pr[z]);
	    standout();
	    printw("[%s]",st[z]);
	    standend();
	    printw("\t%s\t%d %s\n",pl[z],h[z],o[z]);
	    }
	printw("\t\t\t");
	standout();
	printw("[---------->>>>-----------]\n");
	standend();
	/*end printing board*/
	for(count=0;count<plnum;count++)
	    printw("$%d\t",mo[count]);
	printw("\n");
	for(count=0;count<plnum;count++)
	    printw("%s\t",player[count]);
	printw("\n");
	for (c=0;c<plnum;c++)
	    dice[c]=0;
	i++;
	if(i>(plnum-1))
	    i=0;
	}
    clear();
    /*printing board*/
    printw("\t\t\t");
    standout();
    printw("[GO--------<<<<-----------]\n");
    standend();
    for(c=0,z=39;c<20,z>19;c++,z--)
	{
	printw("%d %s\t%s\t",h[c],o[c],pl[c]);
	standout();
	printw("[%s]",st[c]);
	standend();
	printw("\t$%d\t$%d\t",pr[c],pr[z]);
	standout();
	printw("[%s]",st[z]);
	standend();
	printw("\t%s\t%d %s\n",pl[z],h[z],o[z]);
	}
    printw("\t\t\t");
    standout();
    printw("[---------->>>>-----------]\n");
    standend();
    /*end printing board*/
    for(count=0;count<plnum;count++)
	printw("$%d\t",mo[count]);
    printw("\n");
    for(count=0;count<plnum;count++)
	printw("%s\t",player[count]);
    printw("\n");
    scrollok(stdscr,TRUE);
    if(ch=='b')
	{
	printw("You are bankrupt\n");
	printw("Game over\n");
	}
    printw("Counting up money");
    for(c=0;c<40;c++)
	{
	for(z=0;z<plnum;z++)
	    if(strcmp(o[c],player[z])==0)
		mo[z]+=pr[c];
	printw(".");
	usleep(50000);
	refresh();
	for(z=0;z<plnum;z++)
	    if(strcmp(o[c],player[z])==0&&h[c]>0)
		mo[z]+=h[c]*hc[c];
	}
    printw("done\n");
    for(count=0;count<plnum;count++)
	printw("$%d\t",mo[count]);
    printw("\n");
    for(count=0;count<plnum;count++)
	printw("%s\t",player[count]);
    printw("\n");
    refresh();
    endwin();
    } 
die()
    {
    refresh();
    endwin();
    exit(0);
    }
